#!/usr/bin/env bash

dn=$(dirname $0)

versao() {
  node -e "console.log(require('$dn/package.json').version);"
}

if [[ "$3" ]]; then
  echo "Argumentos desnecessários."

  exit "1"
fi

comando="$1"
imagem="$2"

if [[ ! "$comando" ]]; then
  echo "Nenhum comando informado."
  echo "Use \`atras help\`."

  exit "1"
elif [[ "$comando" == "ajuda" ]]; then
  echo ""
  echo "  Uso: atras [add|ver|del] <imagem>"
  echo ""
  echo "  Outros comandos:"
  echo "    ajuda   Exibe isto."
  echo "    versão  Exibe a versão atual."
  echo ""

  exit "0"
elif [[ "$comando" == "versão" ]]; then
  echo "v$(versao)"

  exit "0"
elif [[ $(echo "$comando" | grep -q -E "^(add|del|ver)$"; echo "$?") == "1" ]]; then
  echo "Comando inválido."

  exit "1"
elif [[ ! "$imagem" ]]; then
  echo "Nenhum arquivo informado."

  exit "1"
elif [[ ! -e "$imagem" ]]; then
  echo "Este arquivo não existe."

  exit "1"
elif [[ $(echo "$imagem" | grep -q -E "\.(jpe?g|png|gif|bmp)$"; echo "$?") == "1" ]]; then
  echo "Arquivo inválido."

  exit "1"
elif [[ "$comando" == "add" ]]; then
  echo "$($dn/js/atras.js ver $imagem)" > ".atras.txt"

  vim ".atras.txt"

  "$dn/js/atras.js" add "$imagem" "$(cat .atras.txt)"

  rm -f ".atras.txt"

  exit "0"
elif [[ "$comando" == "ver" ]]; then
  descricao="$($dn/js/atras.js ver $imagem)"

  if [[ "$descricao" ]]; then
    echo "$descricao"

    exit "0"
  else
    echo "Não há uma descrição nesta imagem."

    exit "1"
  fi
else
  "$dn/js/atras.js" del "$imagem"

  exit "0"
fi